from Products.CMFCore.DirectoryView import addDirectoryViews, registerDirectory, createDirectoryView
from Products.CMFCore.TypesTool import  ContentFactoryMetadata, FactoryTypeInformation
from Products.CMFCore.utils import getToolByName
from Products.CMFQuestions import myglobals 
from Products.ExternalMethod import ExternalMethod

from Globals import package_home
import os, string
from StringIO import StringIO

def install_skin(self, outStream, skinName, skinFolder):
    """ """

    skinstool=getToolByName(self, 'portal_skins')
    path = skinstool.getSkinPath('Plone Default') 
    if not path:
        outStream.write('Plone skin not found, aborting\n')
        return
    path = map( string.strip, string.split( path,',' ) )

    if type(skinFolder)==type(''):
        skinFolder=(skinFolder, )

    for folder in skinFolder:
        try:
            path.insert( path.index( 'custom')+1, folder )
        except ValueError:
            path.append(folder)
	
    path = string.join( path, ', ' )
    skinstool.addSkinSelection( skinName, path )

def load(self, outStream):
    """
    installs a sample Website Content and supporting skin
    """
    root=getToolByName(self, 'portal_url').getPortalObject()
 
    #add skin
    skinstool=getToolByName(self, 'portal_skins')
    addDirectoryViews(skinstool, 'skins', myglobals)
    install_skin(self, outStream, 'Questionnaires', ['questions'])

    #adds the directory views to the END of all the other skins
    skin_map=skinstool._getSelections()
    for skin_name, skin_path in skinstool.getSkinPaths():
        if skin_name!='Questionnaires':
            skin_map[skin_name]=skin_path+',questions'

    #add content types.  NOTE: need CMF1.3 or greater.
    typestool=getToolByName(self, 'portal_types')
    typestool.manage_addTypeInformation( FactoryTypeInformation.meta_type
                                       , id='Questionnaire'
                                       , typeinfo_name='CMFQuestions: Questionnaire' )
def install(self):
    out=StringIO()
    load(self, out)
    out.write('Successfully installed the questionnaire.\n')
    return out.getvalue()


